<script lang="typescript">
  import { Page } from "src/page";
  import Fa from "svelte-fa";
  import {
    faCartPlus,
    faFlag,
    faHome,
faLayerGroup,
        faList,
    faReceipt,
    faSignOutAlt,
    faUser,
  } from "@fortawesome/free-solid-svg-icons";
  import type { IconDefinition } from "@fortawesome/fontawesome-common-types";
  import {
    formViewMode,
    isAuthSuccess,
    pageSelectedStore,
    productSelectedStore,
  } from "src/store";
  import type { MenuSlideBarModel } from "src/models/menu.slidebar.type";
  import { logoutFn } from "src/functions/logout";
  import { onMount } from "svelte";

  const dashBoard: MenuSlideBarModel = {
    id: 0,
    name: "หน้าหลัก",
    icon: faUser,
    page: Page["DASHBOARD"],
  };

  const reportMenu: MenuSlideBarModel[] = [
    {
      id: 0,
      name: "ออกรายงานการขาย",
      icon: faReceipt,
      page: Page["SALES_REPORT"],
    },
    {
      id: 0,
      name: "ออกรายงานสมาชิก",
      icon: faReceipt,
      page: Page["USERS_REPORT"],
    },
  ];

  let slideBarSelected: MenuSlideBarModel;

  onMount(() => {
    slideBarSelected = dashBoard;
    setTimeout(() => {
      $pageSelectedStore = dashBoard.page;
    }, 1000);
  });

  const menuProductList: MenuSlideBarModel[] = [
    {
      id: 1,
      name: "จัดการสินค้า",
      icon: faCartPlus,
      page: Page["PRODUCT_MANAGE"],
    },
    { id: 2, name: "รายการสินค้า", icon: faList, page: Page["PRODUCT_LIST"] },
    {
      id: 3,
      name: "จัดการประเภท/กลุ่มสินค้า",
      icon: faLayerGroup,
      page: Page["PRODUCT_GROUP_TYPE"],
    }
  ];

  const menuUserList: MenuSlideBarModel[] = [
    { id: 5, name: "รายการสั่งสินค้า", icon: faUser, page: Page["BILL_ORDER"] },
    { id: 6, name: "ลูกค้า", icon: faList, page: Page["USERLIST"] },
    { id: 7, name: "ออกจากระบบ", icon: faSignOutAlt, page: Page["LOGIN"] },
  ];

  function onSelectMenu(menu: MenuSlideBarModel) {
    if (menu.name == "จัดการสินค้า") {
      $productSelectedStore = {
        uuid: "",
        productId: "", // รหัสสินค้า
        productName: "", // ชื่อสินค้า
        productDesc: "", // รายละเอียดสินค้า
        productOptions: [],
        image: [], // รูปภาพสินค้ามีได้หลายรูป
        discount: 0, // ราคาส่วนลดสินค้า คิดเป็นเปอร์เซ็นต์
        price: 0, // ราคาสินค้า
        selected: false, // ถูกเลือกหรือไม่ถูกเลือก
        productType: [], // ประเภทสินค้า
        group: [], // หมวดหมู่ ขายดี ลดราคา ได้รับความนิยม
        amount: 0, // จำนวนชิ้นที่เลือก
        postDate: "", // วันที่ลงสินค้า
      };
    } else if (menu.name == "ออกจากระบบ") {
      logoutFn();
    }
    slideBarSelected = menu;
    $pageSelectedStore = menu.page;
  }
</script>

<nav
  class="flex relative z-10 flex-wrap justify-between items-center py-4 px-6 leading-6 text-gray-800 bg-white md:block md:flex-row md:flex-no-wrap md:overflow-hidden md:overflow-y-auto md:fixed md:inset-y-0 md:left-0 md:w-64 shadow-xs"
>
  <div
    class="flex flex-wrap justify-between items-center px-0 mx-auto w-full text-gray-800 md:flex-col md:flex-no-wrap md:items-stretch md:min-h-full"
  >
    <div
      on:click={() => onSelectMenu(dashBoard)}
      class="inline-block py-4 px-0 mr-0 text-sm font-bold leading-5 text-left text-red-500 uppercase cursor-pointer  md:block md:pb-2 whitespace-no-wrap"
    >
      <span class="hidden uppercase sm:block text-xl"> ระบบจัดการร้านค้า </span>
      <div
        class="flex items-center p-2 {slideBarSelected?.name == 'หน้าหลัก'
          ? 'text-white bg-gradient-to-r from-red-400 to-yellow-500'
          : 'text-gray-500 hover:text-red-600 '}"
      >
        <Fa size="lg" class="px-3" icon={faHome} />
        <span class="hidden uppercase sm:block text-xs"> หน้าหลัก </span>
      </div>
    </div>
    <div
      class="inline-block py-4 px-0 mr-0 text-sm font-bold leading-5 text-left uppercase cursor-pointer  md:block md:pb-2 whitespace-no-wrap"
    >
      <span class="hidden uppercase sm:block text-xl"> รายงาน </span>
      <ul
        class="flex flex-col p-0 m-0 list-none md:flex-col md:min-w-full"
        style="list-style: none;"
      >
        {#each reportMenu as menuProd}
          <li
            on:click={() => onSelectMenu(menuProd)}
            class="items-center text-left {slideBarSelected?.name ==
            menuProd?.name
              ? 'bg-gradient-to-r from-red-400 to-yellow-500'
              : ''}"
          >
            <div
              class="flex block py-3 text-xs font-bold leading-4 {slideBarSelected?.name ==
              menuProd?.name
                ? 'text-white hover:text-white'
                : 'text-gray-400 hover:text-red-600'} uppercase cursor-pointer"
              style="list-style: outside none none;"
            >
              <Fa size="lg" class="px-3" icon={menuProd.icon} />
              {menuProd?.name}
            </div>
          </li>
        {/each}
      </ul>
    </div>

    <div
      class="inline-block py-4 px-0 mr-0 text-sm font-bold leading-5 text-left uppercase cursor-pointer  md:block md:pb-2 whitespace-no-wrap"
    >
      <hr
        class="mx-0 h-0 border-r-0 border-b-0 border-l-0 border-t border-gray-300 border-solid md:min-w-full box-border"
        style="border-width: 0px;"
      />
      <h6
        class="flex block pt-1 pb-4 m-0 text-xl border-b border-gray-200 font-bold leading-4 text-gray-600 no-underline uppercase md:min-w-full"
      >
        สินค้า <Fa size="sm" class="px-3" icon={faCartPlus} />
      </h6>
      <ul
        class="flex flex-col p-0 m-0 list-none md:flex-col md:min-w-full"
        style="list-style: none;"
      >
        {#each menuProductList as menuProd}
          <li
            on:click={() => onSelectMenu(menuProd)}
            class="items-center text-left {slideBarSelected?.name ==
            menuProd?.name
              ? 'bg-gradient-to-r from-red-400 to-yellow-500'
              : ''}"
          >
            <div
              class="flex block py-3 text-xs font-bold leading-4 {slideBarSelected?.name ==
              menuProd?.name
                ? 'text-white hover:text-white'
                : 'text-gray-400 hover:text-red-600'} uppercase cursor-pointer"
              style="list-style: outside none none;"
            >
              <Fa size="lg" class="px-3" icon={menuProd.icon} />
              {menuProd?.name}
            </div>
          </li>
        {/each}
      </ul>
      <hr
        class="my-4 mx-0 h-0 border-r-0 border-b-0 border-l-0 border-t border-gray-300 border-solid md:min-w-full box-border"
        style="border-width: 0px;"
      />
      <h6
        class="flex block pt-1 pb-4 m-0 text-xl border-b border-gray-200 font-bold leading-4 text-gray-600 no-underline uppercase md:min-w-full"
      >
        ลูกค้า <Fa size="sm" class="px-3" icon={faUser} />
      </h6>
      <ul
        class="flex flex-col p-0 m-0 list-none md:flex-col md:min-w-full"
        style="list-style: none;"
      >
        {#each menuUserList as menuProd}
          <li
            on:click={() => onSelectMenu(menuProd)}
            class="items-center text-left {slideBarSelected?.name ==
            menuProd?.name
              ? 'bg-gradient-to-r from-red-400 to-yellow-500'
              : ''}"
          >
            <div
              class="flex block py-3 text-xs font-bold leading-4 {slideBarSelected?.name ==
              menuProd?.name
                ? 'text-white hover:text-white'
                : 'text-gray-400 hover:text-red-600'} uppercase cursor-pointer"
              style="list-style: outside none none;"
            >
              <Fa size="lg" class="px-3" icon={menuProd.icon} />
              {menuProd?.name}
            </div>
          </li>
        {/each}
      </ul>
    </div>
  </div>
</nav>
